#ifndef LIST_H
#define LIST_H

typedef struct property
{
  struct property *prev,*next;
  char *name;
  char *value;
} property;

typedef struct node
{
  struct node *prev,*next;
  struct property *properties;
} node;

struct node *nodealloc();
struct node *nodeadd(struct node *set,struct node *n);
struct node *nodedel(struct node *n);
struct node *nodefree(struct node *n);
void nodesetprop(struct node *n,char *name,char *value);
void nodesetpropint(struct node *n,char *name,int value);
void nodesetprophint(struct node *n,char *name,unsigned int value);
char *nodegetprop(struct node *n,char *name);

int nodesh(char *cmd,struct node *devices,int loopmode);
struct node *nodecondremove(struct node *devices,char *name,char *value,int cond);
struct node *nodeload(char *filename);
int nodesave(char *filename,struct node *devices);
struct node *nodecopy(struct node *devices);
struct node *nodeclone(struct node *curdev);

struct node *nodemerge(struct node *devices1,struct node *devices2,char *uniq);
struct node *nodediff(struct node *devices1,struct node *devices2,char *uniq,char *field);

struct property *propertyalloc();
struct property *propertyadd(struct property *set,struct property *nprop);
struct property *propertysearch(char *name,struct property *set);
struct property *propertydel(struct property *cur);
int propertyset(struct property *prop,char *name,char *value);

int shenv(char *cmd,char **env);

#endif
