#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "haps.h"
#include "md5.h"
#include "list.h"
#include "module.h"

struct node *probe(struct node *devices,int params)
{
  FILE *f,*f2;
  char buf[0x100],sector[512];
  struct node *newdev,*curdev;
  MD5_CTX context;
  unsigned char digest[16];
  int i,type,count,start,end,blocks,active;
  char dev[0x100],name[0x100];

  devices=nodecondremove(devices,"BUS","PARTITION",1);

  count=0;
  for (curdev=devices;curdev!=NULL;curdev=curdev->next)
  {
    if (strcmp(nodegetprop(curdev,"CLASS"),"HD")==0)
    {
//      if (strncmp(nodegetprop(curdev,"DEVICE"),"/dev/hd",7)==0)
//      {
//      }
      sprintf(buf,"/sbin/fdisk -l %s",nodegetprop(curdev,"DEVICE"));
      f=popen(buf,"r");
      while (fgets(buf,sizeof(buf),f)>0)
      {
	if (strncmp(buf,nodegetprop(curdev,"DEVICE"),strlen(nodegetprop(curdev,"DEVICE")))==0)
	{
	  active=0;
	  for (i=0;i<0x100;i++)
	  {
	    if (buf[i]=='*')
	    {
              active=1;
	      buf[i]=' ';
	      break;
	    }
	  }
	  sscanf(buf,"%s %d %d %d %x %s",dev,&start,&end,&blocks,&type,name);

	  f2=fopen(dev,"rb");
	  if (f2)
	  {
            newdev=nodealloc();
            nodesetprop(newdev,"BUS","PARTITION");
            sprintf(buf,"part.%d",count++);
            nodesetprop(newdev,"CONN",buf);
            nodesetprop(newdev,"CLASS","PARTITION");
            nodesetprop(newdev,"DEVICE",dev);
            nodesetprop(newdev,"ACTIVE",active?"YES":"NO");
            nodesetpropint(newdev,"START",start);
            nodesetpropint(newdev,"END",end);
            nodesetpropint(newdev,"BLOCKS",blocks);
            nodesetpropint(newdev,"TYPE",type);
            nodesetprop(newdev,"NAME",name);

            switch(type)
	    {
	      case 0x01:
	      case 0x04:
	      case 0x06:
	      case 0x0B:
	      case 0x0C:
	      case 0x0E:
	      case 0x0F:
                nodesetprop(newdev,"FSTABTYPE","vfat");
	        break;
	      case 0x07:
	      case 0x86:
	      case 0x87:
                nodesetprop(newdev,"FSTABTYPE","ntfs");
	        break;
	      case 0x82: // linux swap
                nodesetprop(newdev,"FSTABTYPE","swap");
	        break;
	      case 0x83: // linux
                nodesetprop(newdev,"FSTABTYPE","auto");
	        break;
	      default:
//                nodesetprop(newdev,"FSTABTYPE","UNKNOWN");
	    }

            MD5Init (&context);
            MD5UpdateS(&context,name);
            MD5Final (digest, &context);
            sprintf(buf,"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
              digest[0],digest[1],digest[2],digest[3],
              digest[4],digest[5],digest[6],digest[7],
              digest[8],digest[9],digest[10],digest[11],
              digest[12],digest[13],digest[14],digest[15]);
            nodesetprop(newdev,"MD5_ID",buf);

            MD5Init (&context);
            fread(sector,sizeof(sector),1,f2);
            MD5Update(&context,sector,sizeof(sector));
            MD5Final (digest, &context);
            sprintf(buf,"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
              digest[0],digest[1],digest[2],digest[3],
              digest[4],digest[5],digest[6],digest[7],
              digest[8],digest[9],digest[10],digest[11],
              digest[12],digest[13],digest[14],digest[15]);
            nodesetprop(newdev,"MD5_STATE",buf);
	    
	    devices = nodeadd(devices,newdev);

            fclose(f2);
	  }
	  
	}
      }
      pclose(f);
    }
  }

  return devices;
}

#ifdef HAPS_MODULES
struct modulehandler *_init_module(void)
{
  struct modulehandler *mh;
  mh=malloc(sizeof(*mh));
  mh->probe=probe;
  return mh;
}
#endif
