%{
  #include <stdlib.h>
  #include "y.tab.h"
//  #define YY_USER_ACTION	printf("%d\n",token);
  #include "probe.h"

  #define DEFAULT_CONFIG_FILE "config.dev"
  #define DEFAULT_PROBE_FILE "probe.dev"

  int lineno=0;
  char linetext[0x400],strng[0x100];
  int temp_int;
  float temp_float;
  char temp_char[100];
  char *tt;

  int yyerror(char *a);

%}

%start str
ID		"$"[_a-zA-Z0-9]*
AP		"'"

LOAD		"LOAD"
SAVE		"SAVE"
PROBE		"PROBE"
FOREACH		"FOREACH"
FORFIRST	"FORFIRST"

ATTACHED	"ATTACHED"
DETACHED	"DETACHED"
PROBED		"PROBED"
LOADED		"LOADED"


SH		"SH"
EXIT		"EXIT"

%{
  #include "y.tab.h"
%}
%%

\n.*		{lineno++;strcpy(linetext,yytext+1);yyless(1);}
[\'][^\']*[\']	{strcpy(strng,yytext+1);strng[strlen(strng)-1]=0;return STRING;}
[\"][^\"]*[\"]	{strcpy(strng,yytext+1);strng[strlen(strng)-1]=0;return STRING;}
{ID}		{strcpy(strng,yytext+1);return ID;}

"#".*		;

{LOAD}		return LOAD;
{SAVE}		return SAVE;
{PROBE}		return PROBE;

{FOREACH}	return FOREACH;
{FORFIRST}	return FORFIRST;

{ATTACHED}	return ATTACHED;
{DETACHED}	return DETACHED;
{PROBED}	return PROBED;
{LOADED}	return LOADED;

{SH}		{return SH;}
{EXIT}		{return EXIT;}

"=="		return EQ;
"!="		return NEQ;

"("		return LEFT_P;
")"		return RIGHT_P;
","		return COMA;
";"		return SEMICOLON;
" "		;

.	{
        sprintf(temp_char,"Nieznany znak: \"%s\", linia: ",yytext);
	yyerror(temp_char);
    };
%%
