%{
  #include <stdio.h>
  #include <stdlib.h>
  #include "list.h"
  #include "probe.h"

  #define DEFAULT_CONFIG_FILE "config.dev"
  #define DEFAULT_PROBE_FILE "probe.dev"

  extern int lineno;
  extern char linetext[0x400];
  extern char strng[0x100];
  extern FILE *yyin; 

  int filemode;
  int loopmode;
  
  char id[0x100];

  struct node *configdevices=NULL,*probeddevices=NULL,*loopdevices=NULL,*newdevs=NULL;
  char lastloaded[0x100];

/*
  char curtype;
  int pstosb=0;
  int nowyblok=1;
  
  int addvar(LISTA *l,char typ,int size,char *nazwa);
  
  int pv=0;
  int printval[0x100];
  int tablica=0;
  
  FILE *mapfile;

  int sizecount[0x100];
  int sizecalc[0x100];
  int sizep=0;
*/

%}

%token	ID NUM NUMF SEMICOLON LEFT_P RIGHT_P COMA
%token	EQ NEQ
%token	PROBE STRING LOAD SAVE FOREACH FORFIRST SH EXIT
%token	ATTACHED DETACHED PROBED LOADED
%left	EQ NEQ
%%

input:
    line
    |
    input line;

line:
    {
      loopmode=0;
      loopdevices=NULL;
    }
    commparam SEMICOLON
    |
    loop state LEFT_P conditions RIGHT_P commsparam SEMICOLON
    {
      loopmode=0;
      loopdevices=nodefree(loopdevices);
    }|
    loop state LEFT_P RIGHT_P commsparam SEMICOLON
    {
      loopmode=0;
      loopdevices=nodefree(loopdevices);
    }
    ;

loop:
    FOREACH
    {
      loopmode=1;
    }|
    FORFIRST
    {
      loopmode=2;
    };

state:
    PROBED
    {
      loopdevices=nodecopy(probeddevices);
    }|
    LOADED
    {
      loopdevices=nodecopy(configdevices);
    }|
    ATTACHED
    {
      loopdevices=nodediff(probeddevices,configdevices,"CONN","CONN");
    }|
    DETACHED
    {
      loopdevices=nodediff(configdevices,probeddevices,"CONN","CONN");
    };

conditions:
    condition COMA conditions
    |
    condition;

condition:
    ID
    {
      strcpy(id,strng);
    }
    EQ STRING
    {
      loopdevices=nodecondremove(loopdevices,id,strng,2);
    }|
    ID
    {
      strcpy(id,strng);
    }
    NEQ STRING
    {
      loopdevices=nodecondremove(loopdevices,id,strng,1);
    };

commsparam:
    commparam COMA commsparam | commparam;

commparam:
    PROBE LEFT_P STRING RIGHT_P
    {
      probeddevices=probe(strng,probeddevices);
//      probeddevices=nodefree(probeddevices);
    };

commparam:
    SH LEFT_P STRING RIGHT_P
    {
      if (loopmode==0)
        shenv(strng,NULL);
      else
        nodesh(strng,loopdevices,loopmode);
    };

commparam:
    EXIT LEFT_P RIGHT_P
    {
      return 0;
    };

commparam:
    fileoper LEFT_P RIGHT_P
    {
      if (filemode==1)
      {
        configdevices=nodefree(configdevices);
        configdevices=nodeload(DEFAULT_CONFIG_FILE);
      } else
      if (filemode==2)
      {
        newdevs=nodecopy(probeddevices);
        newdevs=nodemerge(newdevs,configdevices,"CONN");
        nodesave(lastloaded,newdevs);
	newdevs=nodefree(newdevs);
      }
    }|
    fileoper LEFT_P STRING RIGHT_P
    {
      if (filemode==1)
      {
        configdevices=nodefree(configdevices);
        configdevices=nodeload(strng);
        sprintf(lastloaded,strng);
      } else
      if (filemode==2)
      {
        newdevs=nodecopy(probeddevices);
        newdevs=nodemerge(newdevs,configdevices,"CONN");
        nodesave(strng,newdevs);
	newdevs=nodefree(newdevs);
      }
    };

fileoper:
    LOAD
    {
      filemode=1;
    }|
    SAVE
    {
      filemode=2;
    };

%%

int yyerror(char *a)
{
  printf("An error occcured: %s, line %d:\n%s\n",a,lineno,linetext);
  return 0;
};

int main(int argc,char **argv)
{
  configdevices=nodeload(DEFAULT_CONFIG_FILE);
  sprintf(lastloaded,DEFAULT_CONFIG_FILE);

  if (argc>0)
  {
     yyin=fopen(argv[1],"r");
  }
  else
  {
    yyin=stdin; // doesn't work with serial probing...
  }
									   
  if (yyparse()!=0)
  {
    return 1;
  };
//  nodesave(DEFAULT_PROBE_FILE,probeddevices);

  configdevices=nodefree(configdevices);
  probeddevices=nodefree(probeddevices);

  return 0;
}
